// naumann@stce.rwth-aachen.de

#include<iostream>

template<typename F, typename S>
class pair {
  F f; const S &s;
public:
  pair(const F &f, const S &s) : f(f), s(s) {}
  F& first(); const S& second();
};

template<typename F, typename S>
F& pair<F,S>::first() { return f; }
template<typename F, typename S>
const S& pair<F,S>::second() { return s; }

int main() {
  bool b=true;
  pair<int,bool> p(42,b);
  std::cout << p.first() << " " 
     << p.second() << std::endl;
  return 0;
}
