// naumann@stce.rwth-aachen.de

#include<iostream>
#include<cassert>

template<typename F, typename S>
class pair {
  F f; const S *s=nullptr;
public:
  pair(const F &f) : f(f) {}
  pair(S *s) : s(s) {}
  F& first(); const S& second();
};

template<typename F, typename S>
F& pair<F,S>::first() { return f; }
template<typename F, typename S>
const S& pair<F,S>::second() { 
  if (s) return *s; else assert(false); 
}

int main() {
  bool b=true;
  {
  pair<int,bool> p(&b);
  std::cout << p.second() << std::endl;
  }
  {
  pair<int,bool> p(42);
  std::cout << p.second() << std::endl;
  }
  return 0;
}
