// naumann@stce.rwth-aachen.de

#include<iostream>

template<typename F, typename S>
class pair {
  static size_t c;
  F f; S s;
public:
  pair() { c++; }
  ~pair() { c--; }
  static const size_t& count() { return c; }
  F& first(); S& second();
};

template<typename F, typename S>
size_t pair<F,S>::c=0;
template<typename F, typename S>
F& pair<F,S>::first() { return f; }
template<typename F, typename S>
S& pair<F,S>::second() { return s; }

int main() {
  pair<int,bool> p1,p2,p3;
  pair<float,char> q1,q2;
  std::cout << pair<int,bool>::count() << std::endl;
  std::cout << pair<float,char>::count() << std::endl;
  return 0;
}
